jQuery(document).ready(function($){

	// 1. when dropped in
	$('div.widgets-sortables').bind('sortstop',function(event,ui){
		nnr_ap_fa_setup_options();
	});

	// 2. do some stuff on load
	nnr_ap_fa_setup_options();

	// 3. on action
	$(document).delegate('.our_widget_class', 'change', function(ev) {
		// you have to find the parent widget here,
		// and do something for it. And this is not easy
		// because the widget shouldn't have it's ID yet, but still possible.
		// This is actually the safest part of the whole process (maybe just for me)
		nnr_ap_fa_setup_options();
	});

	// 4. on save
	$('body').ajaxSuccess(function(evt, request, settings) {
		nnr_ap_fa_setup_options();
	});

	/**
	 * Setup all the options for the Featured Author widget settings
	 *
	 * @access public
	 * @return void
	 */
	function nnr_ap_fa_setup_options() {

		// Selectize - Author

	  	var author_options = [];

	  	$.each(nnr_ap_fa_widget_settings.authors, function( index, value ) {
		  	author_options.push( {id: value.ID, name: value.data.display_name} );
		});

		$('.' + nnr_ap_fa_widget_settings.prefix_dash + 'author').each(function(index, value){

			if ( !$(value).hasClass('selectized') ) {
				$(value).selectize({
				  	plugins: ['remove_button'],
				  	valueField: 'id',
					labelField: 'name',
					searchField: 'name',
				  	options: author_options,
				  	maxItems: 1,
			  	});
			}
		});

		// Selectize - Fancy Colors

		$.each($("input." + nnr_ap_fa_widget_settings.prefix_dash + "fancy-colors-selectize"), function(key, value){

			$('input.' + nnr_ap_fa_widget_settings.prefix_dash + 'fancy-colors-selectize.selectized').hide();

			if (!$(value).hasClass('selectized')) {
				$(value).selectize({
					plugins: ['drag_drop', 'remove_button'],
					valueField: 'hex',
				    labelField: 'name',
				    searchField: 'name',
				    options: [
				       	{hex: '#61BD6D', name: 'Fern'},
				        {hex: '#1ABC9C', name: 'Mountain Meadow'},
				        {hex: '#54ACD2', name: 'Picton Blue'},
				        {hex: '#2C82C9', name: 'Mariner'},
				        {hex: '#9365B8', name: 'Wisteria'},
				        {hex: '#457757', name: 'Chambray'},
				        {hex: '#41A85F', name: 'Chateau Green'},
				        {hex: '#00A885', name: 'Persian Green'},
				        {hex: '#3D8EB9', name: 'Curious Blue'},
				        {hex: '#2969B0', name: 'Denim'},
				        {hex: '#553982', name: 'Blue Gem'},
				        {hex: '#28324E', name: 'Blue Whale'},
				        {hex: '#F7DA64', name: 'Energy'},
				        {hex: '#FBA026', name: 'Neon Carrot'},
				        {hex: '#EB6B56', name: 'Terra Cotta'},
				        {hex: '#E14938', name: 'Cinnabar'},
				        {hex: '#A38F84', name: 'Almond Frost'},
				        {hex: '#EFEFEF', name: 'White Smoke'},
				        {hex: '#FAC51C', name: 'Turbo'},
				        {hex: '#F37934', name: 'Sun'},
				        {hex: '#D14841', name: 'Valencia'},
				        {hex: '#B8312F', name: 'Well Road'},
				        {hex: '#75706B', name: 'Iron Gray'},
				        {hex: '#D1D5D8', name: 'Iron'},
					],
				    onChange: function(){
					    $.each($(".selectize-input .item"), function(key, value){
							$(value).css('background-color', $(value).data('value'));

							if ($(value).data('value') == '#457757' ||
								$(value).data('value') == '#2969B0' ||
								$(value).data('value') == '#553982' ||
								$(value).data('value') == '#28324E' ||
								$(value).data('value') == '#75706B') {
								$(value).css('color', 'white');
							}
						});
				    },
				    render: {
					    option: function(data, escape) {

						    if (data.hex == '#457757' ||
								data.hex == '#2969B0' ||
								data.hex == '#553982' ||
								data.hex == '#28324E' ||
								data.hex == '#75706B') {
								return '<div class="option" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
							}

						    return '<div class="option" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
					    },
					    item : function(data, escape) {

						    if (data.hex == '#457757' ||
								data.hex == '#2969B0' ||
								data.hex == '#553982' ||
								data.hex == '#28324E' ||
								data.hex == '#75706B') {
								return '<div class="item" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
							}

						    return '<div class="item" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
					    }
				    }
				});
			}
		});

		// Color Picker

		$('.' + nnr_ap_widget_settings.prefix_dash + 'bg-color-picker').each(function(index, value){

			if ( !$(value).hasClass('wp-color-picker') ) {
				$(value).wpColorPicker({
					defaultColor: '#efefef'
				});
			}
		});

		$('.' + nnr_ap_widget_settings.prefix_dash + 'color-picker').each(function(index, value){

			if ( !$(value).hasClass('wp-color-picker') ) {
				$(value).wpColorPicker({
					defaultColor: '#333'
				});
			}
		});
	}

});