jQuery(document).ready(function($){

	// Hide and show the Shortcode builder panel

	$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder').click(function(e){
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-box').show();
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').show();
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').addClass('fade in');
		e.preventDefault();
	});

	$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-close').click(function(e){
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-box').hide();
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').hide();
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');
		e.preventDefault();
	});

	$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-add').click(function(e){
		e.preventDefault();

		var selected_text = tinyMCE.activeEditor.selection.getContent( {format : "text"} );

		if ( selected_text != '') {
			wp.media.editor.insert('<span data-optin-fire-custom-button="' + $('#' + nnr_ap_shortcode.prefix + 'id').val() + '">' + selected_text + '</span>');
		} else {
			wp.media.editor.insert($('.' + nnr_ap_shortcode.prefix + 'shortcode').html());
		}

		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-box').hide();
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').hide();
		$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');
	});

	$('body').on('click', function(e){
		if ($('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').is(e.target)) {
			$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-box').hide();
			$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').hide();
			$('.' + nnr_ap_shortcode.prefix + 'shortcode-builder-container').removeClass('fade in');
		}
	});

	// Creating the shortcode

	var shortcode = '[nnr_author_posts]';

	$.each( $("." + nnr_ap_shortcode.prefix + "shortcode-input"), function(key, value) {

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(value).val();

		if ($(value).is(':checkbox')) {
			val = $(this).prop('checked');
		}

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex , $(value).data('shortcode') + '="' + val + '"');
		}

		$("." + nnr_ap_shortcode.prefix + "shortcode").html(shortcode);

	});

	$("." + nnr_ap_shortcode.prefix + "shortcode-input").keyup(function(){

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(this).val();

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(this).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(this).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_ap_shortcode.prefix + "shortcode").html(shortcode);

	}).change(function(){

		var regex = new RegExp('(' + $(this).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(this).val();

		if ($(this).is(':checkbox')) {
			val = $(this).prop('checked');
		}

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(this).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(this).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_ap_shortcode.prefix + "shortcode").html(shortcode);

	});

	// Selectize - Author

  	var author_options = [];

  	author_options.push( {id: 0, name: '--- Current Author ---'} );

  	$.each(nnr_ap_shortcode.authors, function( index, value ) {
	  	author_options.push( {id: value.ID, name: value.data.display_name} );
	});

	$('#' + nnr_ap_shortcode.prefix + 'author').selectize({
	  	plugins: ['remove_button'],
	  	valueField: 'id',
		labelField: 'name',
		searchField: 'name',
	  	options: author_options,
	  	maxItems: 1,
  	});

  	// Color Picker

	$('.' + nnr_ap_shortcode.prefix + 'bg-color-picker').each(function(index, value){

		if ( !$(value).hasClass('wp-color-picker') ) {
			$(value).wpColorPicker({
				defaultColor: '#efefef',
				change: function() {
					nnr_ap_color_picker_change($(this));
				}
			});
		}
	});

	$('.' + nnr_ap_shortcode.prefix + 'color-picker').each(function(index, value){

		if ( !$(value).hasClass('wp-color-picker') ) {
			$(value).wpColorPicker({
				defaultColor: '#333',
				change: function() {
					nnr_ap_color_picker_change($(this));
				}
			});
		}
	});

	/**
	 * Trigger the shortcode change when the color changes
	 *
	 * @access public
	 * @param mixed value
	 * @return void
	 */
	function nnr_ap_color_picker_change(picker) {
		var regex = new RegExp('(' + $(picker).data('shortcode') + '="(?:[^\\"]+|\\.)*")');

		var val = $(picker).wpColorPicker('color');;

		if (shortcode.match(regex)) {
			shortcode = shortcode.replace(regex, $(picker).data('shortcode') + '="' + val + '"');
		} else {
			shortcode = shortcode.replace(']', ' ' + $(picker).data('shortcode') + '="' + val + '"]');
		}

		$("." + nnr_ap_shortcode.prefix + "shortcode").html(shortcode);
	}

	$("#" + nnr_ap_shortcode.prefix + "fancy-colors").selectize({
		plugins: ['drag_drop', 'remove_button'],
		valueField: 'hex',
	    labelField: 'name',
	    searchField: 'name',
	    options: [
	       	{hex: '#61BD6D', name: 'Fern'},
	        {hex: '#1ABC9C', name: 'Mountain Meadow'},
	        {hex: '#54ACD2', name: 'Picton Blue'},
	        {hex: '#2C82C9', name: 'Mariner'},
	        {hex: '#9365B8', name: 'Wisteria'},
	        {hex: '#457757', name: 'Chambray'},
	        {hex: '#41A85F', name: 'Chateau Green'},
	        {hex: '#00A885', name: 'Persian Green'},
	        {hex: '#3D8EB9', name: 'Curious Blue'},
	        {hex: '#2969B0', name: 'Denim'},
	        {hex: '#553982', name: 'Blue Gem'},
	        {hex: '#28324E', name: 'Blue Whale'},
	        {hex: '#F7DA64', name: 'Energy'},
	        {hex: '#FBA026', name: 'Neon Carrot'},
	        {hex: '#EB6B56', name: 'Terra Cotta'},
	        {hex: '#E14938', name: 'Cinnabar'},
	        {hex: '#A38F84', name: 'Almond Frost'},
	        {hex: '#EFEFEF', name: 'White Smoke'},
	        {hex: '#FAC51C', name: 'Turbo'},
	        {hex: '#F37934', name: 'Sun'},
	        {hex: '#D14841', name: 'Valencia'},
	        {hex: '#B8312F', name: 'Well Road'},
	        {hex: '#75706B', name: 'Iron Gray'},
	        {hex: '#D1D5D8', name: 'Iron'},
		],
	    onChange: function(){
		    $.each($(".selectize-input .item"), function(key, value){
				$(value).css('background-color', $(value).data('value'));

				if ($(value).data('value') == '#457757' ||
					$(value).data('value') == '#2969B0' ||
					$(value).data('value') == '#553982' ||
					$(value).data('value') == '#28324E' ||
					$(value).data('value') == '#75706B') {
					$(value).css('color', 'white');
				}
			});
	    },
	    render: {
		    option: function(data, escape) {

			    if (data.hex == '#457757' ||
					data.hex == '#2969B0' ||
					data.hex == '#553982' ||
					data.hex == '#28324E' ||
					data.hex == '#75706B') {
					return '<div class="option" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
				}

			    return '<div class="option" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
		    },
		    item : function(data, escape) {

			    if (data.hex == '#457757' ||
					data.hex == '#2969B0' ||
					data.hex == '#553982' ||
					data.hex == '#28324E' ||
					data.hex == '#75706B') {
					return '<div class="item" style="background-color:' + data.hex + ';color:#ffffff;">' + escape(data.name) + '</div>';
				}

			    return '<div class="item" style="background-color:' + data.hex + ';">' + escape(data.name) + '</div>';
		    }
	    }
	});

	// Hide and show layout options

	$("." + nnr_ap_shortcode.prefix + "color").hide();
	$("." + nnr_ap_shortcode.prefix + "text-color").hide();
	$("." + nnr_ap_shortcode.prefix + "fancy-colors").hide();
	$("." + nnr_ap_shortcode.prefix + "grid-size").hide();
	$("." + nnr_ap_shortcode.prefix + "show-nav").hide();

	if ($("." + nnr_ap_shortcode.prefix + "layout").val() == "image_tiles" ||
		$("." + nnr_ap_shortcode.prefix + "layout").val() == "image_flip" ||
		$("." + nnr_ap_shortcode.prefix + "layout").val() == "fancy_colors" ||
		$("." + nnr_ap_shortcode.prefix + "layout").val() == "colored_tabs") {
		$("." + nnr_ap_shortcode.prefix + "color").show();
	}

	if (!$("." + nnr_ap_shortcode.prefix + "layout").val() == "grid" &&
		!$("." + nnr_ap_shortcode.prefix + "layout").val() == "slider") {

		$("." + nnr_ap_shortcode.prefix + "text-color").show();
	}

	if ($("." + nnr_ap_shortcode.prefix + "layout").val() == "grid") {
		$("." + nnr_ap_shortcode.prefix + "grid-size").show();
	}

	if ($("." + nnr_ap_shortcode.prefix + "layout").val() == "fancy_colors" ||
		$("." + nnr_ap_shortcode.prefix + "layout").val() == "colored_tabs") {
		$("." + nnr_ap_shortcode.prefix + "fancy-colors").show();
	}

	if ($("." + nnr_ap_shortcode.prefix + "layout").val() == "slider") {
		$("." + nnr_ap_shortcode.prefix + "show-nav").show();
	}

	// Hide and show color options

	$("." + nnr_ap_shortcode.prefix + "color").hide();
	$("." + nnr_ap_shortcode.prefix + "text-color").hide();

	if ($("." + nnr_ap_shortcode.prefix + "style-override").prop("checked")) {

		if ($("." + nnr_ap_shortcode.prefix + "layout").val() != "grid" &&
			$("." + nnr_ap_shortcode.prefix + "layout").val() != "slider") {

			$("." + nnr_ap_shortcode.prefix + "text-color").show();
		}

		if ($("." + nnr_ap_shortcode.prefix + "layout").val() == "image_tiles" ||
			$("." + nnr_ap_shortcode.prefix + "layout").val() == "image_flip" ||
			$("." + nnr_ap_shortcode.prefix + "layout").val() == "fancy_colors" ||
			$("." + nnr_ap_shortcode.prefix + "layout").val() == "colored_tabs") {

			$("." + nnr_ap_shortcode.prefix + "color").show();
		}

	}

	$("." + nnr_ap_shortcode.prefix + "style-override").change(function(){

		$("." + nnr_ap_shortcode.prefix + "color").hide();
		$("." + nnr_ap_shortcode.prefix + "text-color").hide();

		if ($(this).prop("checked")) {

			if ($("." + nnr_ap_shortcode.prefix + "layout").val() != "grid" &&
				$("." + nnr_ap_shortcode.prefix + "layout").val() != "slider") {

				$("." + nnr_ap_shortcode.prefix + "text-color").show();
			}

			if ($("." + nnr_ap_shortcode.prefix + "layout").val() == "image_tiles" ||
				$("." + nnr_ap_shortcode.prefix + "layout").val() == "image_flip" ||
				$("." + nnr_ap_shortcode.prefix + "layout").val() == "fancy_colors" ||
				$("." + nnr_ap_shortcode.prefix + "layout").val() == "colored_tabs") {

				$("." + nnr_ap_shortcode.prefix + "color").show();
			}
		}

	});

	// Layout Change

	$("." + nnr_ap_shortcode.prefix + "layout").change(function(){

		$("." + nnr_ap_shortcode.prefix + "color").hide();
		$("." + nnr_ap_shortcode.prefix + "text-color").hide();
		$("." + nnr_ap_shortcode.prefix + "fancy-colors").hide();
		$("." + nnr_ap_shortcode.prefix + "grid-size").hide();
		$("." + nnr_ap_shortcode.prefix + "show-nav").hide();

		if ($("." + nnr_ap_shortcode.prefix + "style-override").prop("checked") && (
			$(this).val() == "image_tiles" ||
			$(this).val() == "image_flip" ||
			$(this).val() == "fancy_colors" ||
			$(this).val() == "colored_tabs" )) {
			$("." + nnr_ap_shortcode.prefix + "color").show();
		}

		if ($("." + nnr_ap_shortcode.prefix + "style-override").prop("checked") &&
			$(this).val() != "grid" &&
			$(this).val() != "slider") {

			$("." + nnr_ap_shortcode.prefix + "text-color").show();
		}

		if ($(this).val() == "grid") {
			$("." + nnr_ap_shortcode.prefix + "grid-size").show();
		}

		if ($(this).val() == "fancy_colors" ||
			$(this).val() == "colored_tabs") {
			$("." + nnr_ap_shortcode.prefix + "fancy-colors").show();
		}

		if ($(this).val() == "slider") {
			$("." + nnr_ap_shortcode.prefix + "show-nav").show();
		}

	});

});