<!-- Title -->

<p>
	<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', NNRobots_Post_Author::$text_domain); ?></label>
	<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo isset($title) ? esc_attr( $title ) : 'Posts by Author'; ?>" />
</p>

<div class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section">

	<p class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section-title"><?php _e('Post Data', NNRobots_Post_Author::$text_domain); ?></p><hr />

	<!-- Number -->

	<p>
		<label><?php _e('Number of Posts to display:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'num_posts' ); ?>" name="<?php echo $this->get_field_name( 'num_posts' ); ?>">
			<option value="all" <?php echo ((isset($num_posts) && $num_posts == 'all') ? 'selected="selected"' : ''); ?>><?php _e('All', NNRobots_Post_Author::$text_domain); ?></option>
		<?php for ($i = 1; $i < 21; $i++) { ?>
			<option value="<?php echo $i; ?>" <?php selected($i, $num_posts, true); ?>><?php _e($i, NNRobots_Post_Author::$text_domain); ?></option>
		<?php } ?>
		</select>
	</p>

	<!-- Sort -->

	<p>
		<label><?php _e('Sort Posts by:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'orderby' ); ?>" name="<?php echo $this->get_field_name( 'orderby' ); ?>">
			<option value="ID" <?php selected('ID', $orderby, true); ?>><?php _e( 'ID', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="title" <?php selected('title', $orderby, true); ?>><?php _e( 'Post Title', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="date" <?php selected('date', $orderby, true); ?>><?php _e( 'Post Date', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="comment_count" <?php selected('comment_count', $orderby, true); ?>><?php _e( 'Comment Count', NNRobots_Post_Author::$text_domain); ?></option>
		</select>
	</p>

	<!-- Order -->

	<p>
		<label><?php _e('Order Posts by:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'order' ); ?>" name="<?php echo $this->get_field_name( 'order' ); ?>">
			<option value="DESC" <?php selected('DESC', $order, true); ?>><?php _e( 'DESC', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="ASC" <?php selected('ASC', $order, true); ?>><?php _e( 'ASC', NNRobots_Post_Author::$text_domain); ?></option>
		</select>
	</p>

</div>

<div class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section">

	<p class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section-title"><?php _e('Author Info', NNRobots_Post_Author::$text_domain); ?></p><hr />

	<!-- Author Layout -->

	<p>
		<label><?php _e('Author Layout:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'author_layout' ); ?>" name="<?php echo $this->get_field_name( 'author_layout' ); ?>">
			<option value="inline" <?php selected('inline', $author_layout, true); ?>><?php _e( 'Inline', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="stacked" <?php selected('stacked', $author_layout, true); ?>><?php _e( 'Stacked', NNRobots_Post_Author::$text_domain); ?></option>
		</select>
	</p>

	<!-- Author Biography -->

	<p>
		<input type="checkbox" id="<?php echo $this->get_field_id( 'author_description' ); ?>" name="<?php echo $this->get_field_name( 'author_description' ); ?>" <?php echo isset($author_description) && $author_description ? 'checked="checked"' : ''; ?> />
		<label><?php _e('Author Biography', NNRobots_Post_Author::$text_domain); ?></label>
	</p>

	<!-- Avatar Shape -->

	<p>
		<label><?php _e('Avatar Shape:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'avatar_shape' ); ?>" name="<?php echo $this->get_field_name( 'avatar_shape' ); ?>">
			<option value="square" <?php selected('square', $avatar_shape, true); ?>><?php _e( 'Square', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="rounded-square" <?php selected('rounded-square', $avatar_shape, true); ?>><?php _e( 'Rounded Square', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="circle" <?php selected('circle', $avatar_shape, true); ?>><?php _e( 'Circle', NNRobots_Post_Author::$text_domain); ?></option>
		</select>
	</p>

	<!-- Avatar Size -->

	<p>
		<label><?php _e('Avatar Size:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'avatar_size' ); ?>" name="<?php echo $this->get_field_name( 'avatar_size' ); ?>">
			<option value="small" <?php selected('small', $avatar_size, true); ?>><?php _e( 'Small', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="medium" <?php selected('medium', $avatar_size, true); ?>><?php _e( 'Medium', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="large" <?php selected('large', $avatar_size, true); ?>><?php _e( 'Large', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="full" <?php selected('full', $avatar_size, true); ?>><?php _e( 'Full', NNRobots_Post_Author::$text_domain); ?></option>
		</select>
	</p>

</div>

<div class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section">

	<p class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section-title"><?php _e('Display Settings', NNRobots_Post_Author::$text_domain); ?></p><hr />

	<!-- Posts Layout -->

	<p>
		<label><?php _e('Post Layout:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'post_layout' ); ?>" name="<?php echo $this->get_field_name( 'post_layout' ); ?>" class="<?php echo $id_prefix; ?>layout">
			<option value="list" <?php selected('list', $post_layout, true); ?>><?php _e( 'List', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="list_excerpt" <?php selected('list_excerpt', $post_layout, true); ?>><?php _e( 'List with Excerpt', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="thumbnail" <?php selected('thumbnail', $post_layout, true); ?>><?php _e( 'Thumbnail', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="numbered_list" <?php selected('numbered_list', $post_layout, true); ?>><?php _e( 'Numbered List', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="image_tiles" <?php selected('image_tiles', $post_layout, true); ?>><?php _e( 'Image Tiles', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="image_flip" <?php selected('image_flip', $post_layout, true); ?>><?php _e( 'Image Flip', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="grid" <?php selected('grid', $post_layout, true); ?>><?php _e( 'Grid', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="slider" <?php selected('slider', $post_layout, true); ?>><?php _e( 'Slider', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="fancy_colors" <?php selected('fancy_colors', $post_layout, true); ?>><?php _e( 'Fancy Colors', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="colored_tabs" <?php selected('colored_tabs', $post_layout, true); ?>><?php _e( 'Colored Tabs', NNRobots_Post_Author::$text_domain); ?></option>
		</select>
	</p>

	<!-- Grid Size -->

	<p class="<?php echo $id_prefix; ?>grid-size">
		<label><?php _e('Grid Size:', NNRobots_Post_Author::$text_domain); ?></label>
		<select id="<?php echo $this->get_field_id( 'grid_size' ); ?>" name="<?php echo $this->get_field_name( 'grid_size' ); ?>">
			<option value="small" <?php selected('small', $grid_size, true); ?>><?php _e( 'Small', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="medium" <?php selected('medium', $grid_size, true); ?>><?php _e( 'Medium', NNRobots_Post_Author::$text_domain); ?></option>
			<option value="large" <?php selected('large', $grid_size, true); ?>><?php _e( 'Large', NNRobots_Post_Author::$text_domain); ?></option>
		</select>
	</p>

	<!-- Fancy Colors -->

	<p class="<?php echo $id_prefix; ?>fancy-colors">
		<strong><label for="<?php echo $this->get_field_id( 'fancy_colors' ); ?>"><?php _e( 'Fancy Colors:', NNRobots_Post_Author::$text_domain); ?></label></strong><br/>
		<input id="<?php echo $this->get_field_id( 'fancy_colors' ); ?>" name="<?php echo $this->get_field_name( 'fancy_colors' ); ?>" value="<?php echo esc_attr( $fancy_colors ); ?>" class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>fancy-colors-selectize" style="display:none;"><br/>
		<em class="<?php echo $id_prefix; ?>fancy-colors"><?php _e('The background color of each item.  Drag and drop to re-order colors.', NNRobots_Post_Author::$text_domain); ?></em>
	</p>

	<!-- Show Nav -->

	<p class="<?php echo $id_prefix; ?>show-nav">
		<input type="checkbox" id="<?php echo $this->get_field_id( 'show_nav' ); ?>" name="<?php echo $this->get_field_name( 'show_nav' ); ?>" <?php echo isset($show_nav) && $show_nav ? 'checked="checked"' : ''; ?> />
		<label><?php _e('Show Navigation Arrows', NNRobots_Post_Author::$text_domain); ?></label>
	</p>

	<!-- Style Override -->

	<p>
		<input id="<?php echo $this->get_field_id( 'style_override' ); ?>" name="<?php echo $this->get_field_name( 'style_override' ); ?>" class="<?php echo $id_prefix; ?>style-override" type="checkbox" <?php echo isset( $style_override ) && $style_override ? 'checked="checked"' : ''; ?>>
		<label for="<?php echo $this->get_field_id( 'style_override' ); ?>"><?php _e( 'Theme Style Override:', NNRobots_Post_Author::$text_domain); ?></label><br/>
		<em><?php _e('Use your own custom styling for text and background, or your themes styling.', NNRobots_Post_Author::$text_domain); ?></em>
	</p>

	<!-- Color -->

	<p class="<?php echo $id_prefix; ?>color">
		<strong><label for="<?php echo $this->get_field_id( 'color' ); ?>"><?php _e( 'Color:', NNRobots_Post_Author::$text_domain); ?></label></strong><br/>
		<input id="<?php echo $this->get_field_id( 'color' ); ?>" name="<?php echo $this->get_field_name( 'color' ); ?>" class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>bg-color-picker color-picker" value="<?php echo esc_attr( $color ); ?>"><br/>
		<em><?php _e('The background color of the image tiles.', NNRobots_Post_Author::$text_domain); ?></em><br/>
		<em><?php _e('Click inside textfield to bring up color picker.', NNRobots_Post_Author::$text_domain); ?></em>
	</p>

	<!-- Text Color -->

	<p class="<?php echo $id_prefix; ?>text-color">
		<strong><label for="<?php echo $this->get_field_id( 'text_color' ); ?>"><?php _e( 'Text Color:', NNRobots_Post_Author::$text_domain); ?></label></strong><br/>
		<input id="<?php echo $this->get_field_id( 'text_color' ); ?>" name="<?php echo $this->get_field_name( 'text_color' ); ?>" class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>color-picker color-picker" value="<?php echo esc_attr( $text_color ); ?>"><br/>
		<em><?php _e('The text color for each item.', NNRobots_Post_Author::$text_domain); ?></em><br/>
		<em><?php _e('Click inside textfield to bring up color picker.', NNRobots_Post_Author::$text_domain); ?></em>
	</p>

</div>

<div class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section">

	<p class="<?php echo NNRobots_Post_Author::$prefix_dash; ?>widget-section-title"><?php _e('Miscellaneous', NNRobots_Post_Author::$text_domain); ?></p><hr />

	<!-- Show On Pages -->

	<p>
		<input type="checkbox" id="<?php echo $this->get_field_id( 'show_on_pages' ); ?>" name="<?php echo $this->get_field_name( 'show_on_pages' ); ?>" <?php echo isset($show_on_pages) && $show_on_pages ? 'checked="checked"' : ''; ?> />
		<label><?php _e('Show on Pages', NNRobots_Post_Author::$text_domain); ?></label>
	</p>

	<!-- Display Asynchronously -->

	<p>
		<input type="checkbox" id="<?php echo $this->get_field_id( 'async' ); ?>" name="<?php echo $this->get_field_name( 'async' ); ?>" <?php echo isset($async) && $async ? 'checked="checked"' : ''; ?> />
		<label><?php _e('Display Asynchronously', NNRobots_Post_Author::$text_domain); ?></label>
	</p>

</div>

<!-- ID -->

<p>
	<strong><label><?php _e( 'ID:', NNRobots_Post_Author::$text_domain); ?></label></strong>
	<code><?php _e($this->id, NNRobots_Post_Author::$text_domain); ?></code>
</p>

<script type="text/javascript">
	jQuery(document).ready(function($){

		var prefix = "<?php echo $id_prefix; ?>";

		// Hide and show layout options

		$("." + prefix + "color").hide();
		$("." + prefix + "text-color").hide();
		$("." + prefix + "fancy-colors").hide();
		$(".nnr-ap-fancy-colors-selectize").hide();
		$("." + prefix + "grid-size").hide();
		$("." + prefix + "show-nav").hide();

		if ($("." + prefix + "layout").val() == 'image_tiles' ||
			$("." + prefix + "layout").val() == 'image_flip' ||
			$("." + prefix + "layout").val() == 'colored_tabs') {
			$("." + prefix + "color").show();
		}

		if (!$("." + prefix + "layout").val() == 'grid' &&
			!$("." + prefix + "layout").val() == 'slider') {

			$("." + prefix + "text-color").show();
		}

		if ($("." + prefix + "layout").val() == 'grid') {
			$("." + prefix + "grid-size").show();
		}

		if ($("." + prefix + "layout").val() == 'fancy_colors' ||
			$("." + prefix + "layout").val() == 'colored_tabs') {
			$("." + prefix + "fancy-colors").show();
			$(".nnr-ap-fancy-colors-selectize").show();
		}

		if ($("." + prefix + "layout").val() == 'slider') {
			$("." + prefix + "show-nav").show();
		}

		// Hide and show color options

		$("." + prefix + "color").hide();
		$("." + prefix + "text-color").hide();

		if ($("." + prefix + "style-override").prop('checked')) {

			if ($("." + prefix + "layout").val() != 'grid' &&
				$("." + prefix + "layout").val() != 'slider') {

				$("." + prefix + "text-color").show();
			}

			if ($("." + prefix + "layout").val() == 'image_tiles' ||
				$("." + prefix + "layout").val() == 'image_flip' ||
				$("." + prefix + "layout").val() == 'colored_tabs') {

				$("." + prefix + "color").show();
			}

		}

		$("." + prefix + "style-override").change(function(){

			$("." + prefix + "color").hide();
			$("." + prefix + "text-color").hide();

			if ($(this).prop('checked')) {

				if ($("." + prefix + "layout").val() != 'grid' &&
					$("." + prefix + "layout").val() != 'slider') {

					$("." + prefix + "text-color").show();
				}

				if ($("." + prefix + "layout").val() == 'image_tiles' ||
					$("." + prefix + "layout").val() == 'image_flip' ||
					$("." + prefix + "layout").val() == 'colored_tabs') {

					$("." + prefix + "color").show();
				}
			}

		});

		// Layout Change

		$("." + prefix + "layout").change(function(){

			$("." + prefix + "color").hide();
			$("." + prefix + "text-color").hide();
			$("." + prefix + "fancy-colors").hide();
			$("." + prefix + "grid-size").hide();
			$("." + prefix + "show-nav").hide();

			if ($("." + prefix + "style-override").prop('checked') && (
				$(this).val() == 'image_tiles' ||
				$(this).val() == 'image_flip' ||
				$(this).val() == 'colored_tabs' )) {
				$("." + prefix + "color").show();
			}

			if ($("." + prefix + "style-override").prop('checked') &&
				$(this).val() != 'grid' &&
				$(this).val() != 'slider') {

				$("." + prefix + "text-color").show();
			}

			if ($(this).val() == 'grid') {
				$("." + prefix + "grid-size").show();
			}

			if ($(this).val() == 'fancy_colors' ||
				$(this).val() == 'colored_tabs') {
				$("." + prefix + "fancy-colors").show();
			}

			if ($(this).val() == 'slider') {
				$("." + prefix + "show-nav").show();
			}

		});
	});
</script>